#ifndef __STRINGS_H
#define __STRINGS_H
// ͻ
//  strings.h, strings.cpp                         
// Ķ
//  C++ string unit                                
// Ķ
//  Written by Gus Smedstad                        
// Ķ
//  Copyright 1990-91 NoGate Consulting            
// ͼ

#include <string.h>

class string {
   char *char_ptr;   // pointer to string contents
   int length;       // length of string in characters
public:
   string();
   string(char text);
   string(char *text);          
   string(int size);        
   string(string& source); 
   ~string();
   string copy(int start, int chars);
   void   insert(int x, char *);
   void   insert(int x, char);
   void   remove(int start, int chars);
   char  *value() {return char_ptr;};
          operator char* () const {return char_ptr;};
   char & operator [] (int i) { return char_ptr[i]; };
   string operator+ (string& arg);
   string operator+ (char *text);
   string operator+ (char text);
   string& operator= (string& arg);
   string& operator= (char *text);
   string& operator= (char text);
   string& operator+= (string& arg);
   string& operator+= (char *text);
   string& operator+= (char text);
   int operator<  (string& arg) 
     {return strcmp(char_ptr, arg.char_ptr) < 0;};
   int operator>  (string& arg)
     {return strcmp(char_ptr, arg.char_ptr) > 0;};
   int operator<= (string& arg)
     {return strcmp(char_ptr, arg.char_ptr) <= 0;};
   int operator>= (string& arg)
     {return strcmp(char_ptr, arg.char_ptr) >= 0;};
   int operator!= (const char *arg)
     {return strcmp(char_ptr, arg) != 0;};
//   int operator== (const string& arg) const;
   int operator== (const char *arg) const
     {return strcmp(char_ptr, arg) == 0;};
 };

string chop(char *text, int length);
string str(char arg);
string str(char *arg);
string str_long(long arg, int width = 0, int leading_zeroes = 0);
inline string str_long(int arg, int width = 0, int z = 0)
 { return str_long((long) arg, width, z); };
string system_date();
string system_time();

void delete_trailing_spaces(char *line);
void delete_chars(char *line, int n);
void delete_leading_spaces(char *line);
string rep_str(int width, char c = ' ');
string ljust(char *arg, int width, char c = ' ');
string rjust(char *arg, int width, char c = ' ');


#endif