#ifndef _MOUSE_HPP
#define _MOUSE_HPP

// ------------------------------------------------------------------
// File:		MOUSE.HPP
// Path:		...\REHACK\EVENT\MOUSE.HPP
// Version:		0.01
// Author:		Pat Reilly
// CIS Id:		71333,2764
// Created On:	6/26/93
// Modified On:
// Description:	Mouse class for REHACK. This is just included because I
//		designed this so I could test the window and event queue classes.
//		See MOUSE.TXT for more details.
// Tabs:		4
// ------------------------------------------------------------------

#ifndef _EVENT_HPP
#include "..\EVENT\EVENT.HPP"
#endif

class Mouse
{
public:

	virtual ~Mouse();

	static bool isPresent();
	static bool install();
	static void remove();
	static void setBounds(const Rect&);
	static void show();
	static void hide();
	static void moveTo(const Point&);
	static void setCursor(const Point&, void*);
	static void setDblClickInterval(word);

	static void getStatus(PosDeviceEvent&);

protected:

	static void huge callbackFunction();
	static bool checkFor();

	static bool  checked;
	static bool  present;
	static bool  installed;
	static Event curEvent;
	static word  dblClickInterval;
	static dword lastLBDown;
	static dword lastRBDown;
	static dword lastCBDown;
};

#endif	// __MOUSE_HPP
