#ifndef _GAME_HPP
#define _GAME_HPP

// ------------------------------------------------------------------
// File:		GAME.HPP
// Path:		...\REHACK\GAME\GAME.HPP
// Version:		0.01
// Author:		Pat Reilly
// CIS Id:		71333,2764
// Created On:	6/28/93
// Modified On:
// Description:	Game class for REHACK. See GAME.TXT for
//				more details.
// Tabs:		4
// ------------------------------------------------------------------

#ifndef _WINDOW_HPP
#include "..\WINDOW\WINDOW.HPP"
#endif

#ifndef _EVENTQ_HPP
#include "..\EVENT\EVENTQ.HPP"
#endif

#ifndef _MOUSE_HPP
#include "..\EVENT\MOUSE.HPP"
#endif

#ifndef _KEYBOARD_CPP
#include "..\event\keyboard.hpp"
#endif

typedef Visible* (*VisMaker)(Rect);

class GameInit
{
public:

	GameInit(VisMaker, VisMaker, VisMaker, VisMaker, VisMaker);

	VisMaker closeUpMaker;
	VisMaker autoMapMaker;
	VisMaker buttonsMaker;
	VisMaker characterMaker;
	VisMaker messageMaker;
};

class Game : public Window, virtual public GameInit
{
public:

	Game(const Rect&);
	virtual ~Game();

	virtual void get(Event&);
	virtual void handle(Event&);
	virtual void idle();

	static bool sendMessage(Visible*, word type, word id, void* info);

	static EventQueue eventQueue;
	static Mouse mouse;
	static Keyboard keyboard;

	static Game* game;
	static Visible* closeUp;
	static Visible* autoMap;
	static Visible* buttons;
	static Visible* character;
	static Visible* message;
};

#endif	// _GAME_HPP
