// --------------------------------------------------------------------------
// File:			FLAGS.HPP
// Path:			...\REHACK\GENERAL\FLAGS.HPP
// Version:			1.00
// Author:			V. James Krammes
// CIS Id:			75300,1663
// Created on:		15-July-1993
// Modified on:
// Description:		This file contains templated flag setting/clearing
//					and testing functions.
// Tabs:			4
// --------------------------------------------------------------------------

#include "..\general\types.hpp"

template <class T>
bool setFlag( T &flags,T mask )
{

	bool r = flagSet( flags,mask );
	flags = flags | mask;
	return r;

}

template <class T>
bool clearFlag( T &flags,T mask )
{

	bool r = flagClear( flags,mask );
	flags &= ~mask;
	return r;

}

template <class T>
bool flagSet( T &flags,T mask )
{

	return (flags & mask) == mask ? true : false;

}

template <class T>
bool flagClear( T &flags,T mask )
{

	return flagSet( flags,mask) ? false : true;

}
